
**********Remark By Bev Howard**********
*
* The following routines are (c) 1992 by
* Beverly Howard, Austin, Texas
* (512) 327-3230
* and released to the public domain provided
* credit for the author remains with
* the source code in every use of this code.
* or portions thereof.
*
* The purpose of this routine is used to trap
* and record instances where a Fox application
* is terminated abnormally and to help educate
* all users of the application that a normal
* program shutdown is essential to
* maintaining data integrity.
*
* The following code is archaic and should
* run in FoxBase+, FoxPro or even dBase
* applications.
*
****************************************




proc startapp
   * run this routine as your program starts
   ******
   * The following code identifies the workstation (not the user)
   * The best way to identify a workstation is to SET a DOS
   * environment variable when the network starts such as;
   *
   * SET STANUM=007
   *
   * (note! CASE sensitive and without spaces at the "=" sign!)
   * This can be done with THE AUTOEXEC.BAT or a Novell login script.
   *
   * The most foolproof way is to set an environment variable that
   * is the network card physical address, then use a database of
   * workstation card addresses to get a 2 or 3 digit character
   * memory variable as a workstation id
   *
   * This ID can also be used for an application to report which
   * workstation has a record or file locked by placing that id in.
   * a special field and FLUSHING immediately after the record is
   * LOCKED and removing it just before the record is UNLOCKED.
   *
   * I also wrote a routine for the Novell environment that automatically
   * creates, keeps and allows updates and modifications to a workstation's
   * physical location, use and status using the network card physical
   * address to minimize user input and preclude errors because of
   * AUTOEXEC.BAT modifications.  It consists of several procedures, a
   * database and Novell login script samples.
   * 
   * It turned out to be very useful manually to track workstation
   * equipment status as well as its id use during application startups.
   * call me if you have the need of such.
   *
   
   
   PUBLIC STAMEM, I_ENDPRG
   
   STORE "WS-"+GETEVN("STANUM")+".MEM" to STAMEM
   IF .NOT. FILE(STAMEM)
      *!!! CREATE ONE
      * (I can't do everything for you. <g>)
      * the following code will, however, create the memory variables
   ENDIF
   
   * this memory file contains the variable "i_endprg" which either contains
   * the string "NORMAL" or the date and time the application was last
   * started on this particular workstation.
   * this file can also be used to store other information to resart the
   * appliction in a state similar to the shutdown state for user
   * convenience (store that info in variables like "i_*"
   
   REST FROM &STAMEM addi
   do case
   case type("i_endprg") = "U"
      * if undefined
      * create the variable that will show the program start time/date
      store dtoc(date())+" @ "+time() to i_endprg
   case i_endprg = "NORMAL"
      * last shutdown was normal
      store dtoc(date())+" @ "+time() to i_endprg
   otherwise
      * computer was shutdown or rebooted within the application
      clear
      store replicate(" ",75) to yn
      if i_endprg = "ERROR"    && modify your error trapping routine
                               && to do this in the event that the
                               && error requires a program shutdown
                               && by the error trapping routine
         @ 1,1 say "This station was shut down because of a program error."
      else
         @ 1,1 say "This station was shut down improperly."
      endif
      @ $+2,1 say "If you know why this station was last shut down and"
      @ $+1,1 say "by who, please take a moment to describe the reason."
      @ $+1,1 say "Thanks"
      @ $+1,1 get yn
      read
      use bherror    && the DBF included in the zip
                     && This DBF is structured to be used by my error
                     && trapping routine to store as much information as
                     && possible every time an unexpected error occurs.
                     && (Makes debugging much less painful and does not
                     && rely on the frailties of human reports.)
                    
      append blank
      if rlock()
         REPLACE ERRTIME WITH TIME()
         REPLACE ERRDATE WITH DATE()
         replace netsta with getenv("STANUM")
         replace errmsg with "Shutdown or Reboot within program."

         replace currprg with i_endprg   && this contains the time and date
                                         && the application was last started
                                         && as well as the id of the user
                                         && who signed in when the program
                                         && was started.  You may want to
                                         && collect more info here.
         replace errline with yn
         flush
         unlock
      endif
      store dtoc(date())+" @ "+time() to i_endprg
   endcase
   store "   " to i_empl
   @ 1,1 say "Please enter your user ID->" get i_empl pict "!!!"
   read

   * save variables in a memory file as a time/date/user marker to show
   * that program is currently in use and by which workstation and user
   save all like i_* to &STAMEM







proc normdown
   * Replace every occurance of QUIT with this procedure
   * to terminate the application
   FLUSH
   store "NORMAL" TO I_ENDPRG
   save all like i_* to &STAMEM
   close all
   quit


